
#include "LCD16X2.h"

#define LCD_RD7     PORTD7_bit      // D7
#define TRISRD7     DDD7_bit

#define LCD_RD6     PORTD6_bit       // D6
#define TRISRD6     DDD6_bit

#define LCD_RD5     PORTD5_bit       // D5
#define TRISRD5     DDD5_bit

#define LCD_RD4     PORTD4_bit        // D4
#define TRISRD4     DDD4_bit

#define LCD_EN      PORTB1_bit       // EN
#define TRISEN      DDB1_bit

#define LCD_RS      PORTB0_bit       // RS
#define TRISRS      DDB0_bit


void Lcd_Begin(){
unsigned char data1;

TRISRD7 = 1;
TRISRD6 = 1;
TRISRD5 = 1;
TRISRD4 = 1;
TRISEN = 1;
TRISRS = 1;
LCD_RD7 = 0;
LCD_RD6 = 0;
LCD_RD5 = 0;
LCD_RD4 = 0;
LCD_EN = 0;
LCD_RS = 0;

delay_ms(33);

for(data1 = 1; data1 < 4; data1 ++)
{
    LCD_RD7 = 0;   LCD_RD6 = 0;    LCD_RD5 = 1;    LCD_RD4 = 1;    LCD_EN = 0;
    LCD_RS = 0;    LCD_RD7 = 0;    LCD_RD6 = 0;    LCD_RD5 = 1;    LCD_RD4 = 1;
    LCD_EN = 1;    LCD_RS = 0;     delay_us(5);
    LCD_RD7 = 0;   LCD_RD6 = 0;    LCD_RD5 = 1;    LCD_RD4 = 1;    LCD_EN = 0;
    LCD_RS = 0;    delay_us(5500);

}
LCD_RD7 = 0; LCD_RD6 = 0; LCD_RD5 = 1; LCD_RD4 = 0; LCD_EN = 0; LCD_RS = 0;
LCD_RD7 = 0; LCD_RD6 = 0; LCD_RD5 = 1; LCD_RD4 = 0; LCD_EN = 1; LCD_RS = 0;
delay_us(5);
LCD_RD7 = 0; LCD_RD6 = 0; LCD_RD5 = 1; LCD_RD4 = 0; LCD_EN = 0; LCD_RS = 0;
delay_us(5500);

Lcd_write_cmd(LCD_RETURN_HOME);
Lcd_write_cmd(LCD_FOR_2LINE);
Lcd_write_cmd(LCD_CLEAR);
Lcd_write_cmd(LCD_DIRECTION);
Lcd_write_cmd(LCD_CURSOR_OFF);
}

void Lcd_Out_strg(unsigned char P, unsigned char L, char *buffer)
{
unsigned char data1;
switch (P)
{
    case 1: data1 = 0x80 + L; break;
    case 2: data1 = 0xC0 + L; break;
    case 3: data1 = 0x94 + L; break;
    case 4: data1 = 0xD4 + L; break;
    default: break;
}
Lcd_write_cmd(data1);
while(*buffer)              // Write data to LCD up to null
{
    Lcd_Chr_Char(*buffer);
    buffer++;               // Increment buffer
}
return;
}

void Lcd_Out_char(unsigned char P, unsigned char L, char ch)
{
unsigned char data1;
switch (P)
{
    case 1: data1 = 0x80 + L; break;
    case 2: data1 = 0xC0 + L; break;
    case 3: data1 = 0x94 + L; break;
    case 4: data1 = 0xD4 + L; break;
    default: break;
}
Lcd_write_cmd(data1);
Lcd_Chr_Char(ch);
return;
}

void Lcd_Chr_Char(char data1){
LCD_EN = 0; LCD_RS = 1;
LCD_RD7 = (data1 & 0x80)>>7; LCD_RD6 = (data1 & 0x40)>>6;
LCD_RD5 = (data1 & 0x20)>>5; LCD_RD4 = (data1 & 0x10)>>4;
delay_ms(2);
LCD_EN = 1; delay_us(5); LCD_EN = 0;
LCD_RD7 = (data1 & 0x08)>>3; LCD_RD6 = (data1 & 0x04)>>2;
LCD_RD5 = (data1 & 0x02)>>1; LCD_RD4 = (data1 & 0x01);
delay_ms(2);
LCD_EN = 1; delay_us(5); LCD_EN = 0;
delay_us(5); delay_us(5500);
}


void Lcd_write_cmd(unsigned char data1){
LCD_EN = 0; LCD_RS = 0;
LCD_RD7 = (data1 & 0x80)>>7; LCD_RD6 = (data1 & 0x40)>>6;
LCD_RD5 = (data1 & 0x20)>>5; LCD_RD4 = (data1 & 0x10)>>4;
delay_ms(2);
LCD_EN = 1; delay_us(5); LCD_EN = 0;
LCD_RD7 = (data1 &  0x08)>>3; LCD_RD6 = (data1 & 0x04)>>2;
LCD_RD5 = (data1 & 0x02)>>1; LCD_RD4 = (data1 & 0x01);
delay_ms(2);
LCD_EN = 1; delay_us(5); LCD_EN = 0;
delay_us(5500);
}